<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for RevRecTemplateRecurrenceList StructType
 * @subpackage Structs
 */
class RevRecTemplateRecurrenceList extends AbstractStructBase
{
    /**
     * The revRecTemplateRecurrence
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * @var \StructType\RevRecTemplateRecurrence[]
     */
    public $revRecTemplateRecurrence;
    /**
     * The replaceAll
     * Meta information extracted from the WSDL
     * - default: true
     * @var bool
     */
    public $replaceAll;
    /**
     * Constructor method for RevRecTemplateRecurrenceList
     * @uses RevRecTemplateRecurrenceList::setRevRecTemplateRecurrence()
     * @uses RevRecTemplateRecurrenceList::setReplaceAll()
     * @param \StructType\RevRecTemplateRecurrence[] $revRecTemplateRecurrence
     * @param bool $replaceAll
     */
    public function __construct(array $revRecTemplateRecurrence = array(), $replaceAll = true)
    {
        $this
            ->setRevRecTemplateRecurrence($revRecTemplateRecurrence)
            ->setReplaceAll($replaceAll);
    }
    /**
     * Get revRecTemplateRecurrence value
     * @return \StructType\RevRecTemplateRecurrence[]|null
     */
    public function getRevRecTemplateRecurrence()
    {
        return $this->revRecTemplateRecurrence;
    }
    /**
     * This method is responsible for validating the values passed to the setRevRecTemplateRecurrence method
     * This method is willingly generated in order to preserve the one-line inline validation within the setRevRecTemplateRecurrence method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateRevRecTemplateRecurrenceForArrayConstraintsFromSetRevRecTemplateRecurrence(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $revRecTemplateRecurrenceListRevRecTemplateRecurrenceItem) {
            // validation for constraint: itemType
            if (!$revRecTemplateRecurrenceListRevRecTemplateRecurrenceItem instanceof \StructType\RevRecTemplateRecurrence) {
                $invalidValues[] = is_object($revRecTemplateRecurrenceListRevRecTemplateRecurrenceItem) ? get_class($revRecTemplateRecurrenceListRevRecTemplateRecurrenceItem) : sprintf('%s(%s)', gettype($revRecTemplateRecurrenceListRevRecTemplateRecurrenceItem), var_export($revRecTemplateRecurrenceListRevRecTemplateRecurrenceItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The revRecTemplateRecurrence property can only contain items of type \StructType\RevRecTemplateRecurrence, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set revRecTemplateRecurrence value
     * @throws \InvalidArgumentException
     * @param \StructType\RevRecTemplateRecurrence[] $revRecTemplateRecurrence
     * @return \StructType\RevRecTemplateRecurrenceList
     */
    public function setRevRecTemplateRecurrence(array $revRecTemplateRecurrence = array())
    {
        // validation for constraint: array
        if ('' !== ($revRecTemplateRecurrenceArrayErrorMessage = self::validateRevRecTemplateRecurrenceForArrayConstraintsFromSetRevRecTemplateRecurrence($revRecTemplateRecurrence))) {
            throw new \InvalidArgumentException($revRecTemplateRecurrenceArrayErrorMessage, __LINE__);
        }
        $this->revRecTemplateRecurrence = $revRecTemplateRecurrence;
        return $this;
    }
    /**
     * Add item to revRecTemplateRecurrence value
     * @throws \InvalidArgumentException
     * @param \StructType\RevRecTemplateRecurrence $item
     * @return \StructType\RevRecTemplateRecurrenceList
     */
    public function addToRevRecTemplateRecurrence(\StructType\RevRecTemplateRecurrence $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\RevRecTemplateRecurrence) {
            throw new \InvalidArgumentException(sprintf('The revRecTemplateRecurrence property can only contain items of type \StructType\RevRecTemplateRecurrence, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->revRecTemplateRecurrence[] = $item;
        return $this;
    }
    /**
     * Get replaceAll value
     * @return bool|null
     */
    public function getReplaceAll()
    {
        return $this->replaceAll;
    }
    /**
     * Set replaceAll value
     * @param bool $replaceAll
     * @return \StructType\RevRecTemplateRecurrenceList
     */
    public function setReplaceAll($replaceAll = true)
    {
        // validation for constraint: boolean
        if (!is_null($replaceAll) && !is_bool($replaceAll)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a bool, %s given', var_export($replaceAll, true), gettype($replaceAll)), __LINE__);
        }
        $this->replaceAll = $replaceAll;
        return $this;
    }
}
